# .qtre.pl
#	qtre: Quick Tool for Raw Editing.
#	(C) 2001 Julian Albo.
#	Definiciones de macros.

sub qtre_macro_1 ()
{
	qtre_status ("Probando, probando");
}

sub qtre_macro_2 ()
{
	qtre_insert ("'Hola, mundo', dicen los clsicos\n");
}

sub qtre_macro_3 ()
{
	require "otro.pl";
	my $r= otro::prueba ();
	qtre_insert ($r);
	qtre_delete ();
}

sub qtre_macro_4 ()
{
	my $l= qtre_line ();
	qtre_insert (qtre_getline ($l - 1) . "\n") unless ($l == 0);
	# Esto es un error
	qtre_delete (1);
}

sub qtre_macro_5 ()
{
	qtre_insert (qtre_line () );
}

sub qtre_macro_6 ()
{
	qtre_insert (qtre_numlines () );
}

sub qtre_macro_7 ()
{
	# Llena sobradamente la linea de estado (supone 80 columnas)
	my $st= '12345678901234567890';
	#$st= $st . $st . $st . $st;
	$st.= $st; $st.= $st;
	qtre_status ($st);
}

sub qtre_macro_8 ()
{
	my $i;
	for ($i= 0; $i < 2000; ++$i) {
		qtre_right ()
	};
}

sub qtre_macro_9 ()
{
	# Copia la linea actual en la barra de estado.
	# Esto se podria hacer mejor con qtre_getline,
	# pero asi se muestra el uso de qtre_getchar.
	my $i;
	my $s= '';
	qtre_home ();
	# qtre_getchar devuelve undef al final del fichero.
	while ( ($i= qtre_getchar () ) ne '' && $i ne "\n") {
		$s.= $i;
		qtre_right ();
	}
	qtre_status ($s);
}


sub qtre_macro_a ()
{
	qtre_up () while (qtre_line () > 0);
}

sub qtre_macro_b ()
{
	# Convierte a mays la linea actual.
	my $l= qtre_getline ();
	$l =~ tr/[a-z]/[A-Z]/;
	qtre_replaceline ($l);
}

sub qtre_macro_c ()
{
	# Copiar linea actual
	$guarda= qtre_getline ();
	qtre_status ("Copiada");
}

sub qtre_macro_f ()
{
	# Ir al final
	qtre_gotoline (qtre_numlines () - 1);
}

sub qtre_macro_i ()
{
	# Invierte 5 lineas.
	my @lins;
	my $i;
	for ($i= 0; $i < 5; ++$i) {
		push (@lins, qtre_getline () );
		qtre_deleteline ();
	}
	for ($i= 0; $i < 5; ++$i) {
		qtre_insert (pop (@lins) );
		qtre_insert ("\n");
	}
}

sub qtre_macro_k ()
{
	qtre_insert ("\nEsta es la macro K\n");
}

sub qtre_macro_n ()
{
	# Numera lineas a partir de la 10 o la actual.
	my $i= qtre_line ();
	if ($i > 10) {
		qtre_gotoline (10);
		$i= 10;
	}
	my $fin= qtre_numlines ();
	while ($i < $fin) {
		qtre_home ();
		qtre_insert ($i . ' ');
		qtre_end ();
		qtre_insert (' ' . $i);
		qtre_down ();
		++$i;
	}
}

sub qtre_macro_p ()
{
	qtre_gotoline (0);
}

sub qtre_macro_q ()
{
	# Crea un monton de lineas
	my $i;
	for ($i= 0; $i < 10000; ++$i) {
		qtre_insert ($i . "\n");
	}
}

sub qtre_macro_r ()
{
	# Rellena unas cuantas lineas
	my $i= 0;
	for ($i= 0; $i < 900; ++$i) {
		qtre_insert ("$i ");
		qtre_insert ("\n") if ($i % 15 == 14);
	}
}

# Prueba
$guarda= "Probando, probando";

sub qtre_macro_v ()
{
	# Pegar linea
	qtre_insert ($guarda);
	qtre_insert ("\n");
	qtre_status ("Pegada");
}

sub qtre_macro_x ()
{
	# Esto es un error:
	qtre_insert ();
	qtre_deleteline ();
}

sub qtre_macro_y ()
{
	# Informa del codigo del caracter bajo el cursor.
	my $i= qtre_getchar ();
	qtre_status (ord ($i) );
}

sub qtre_macro_z ()
{
	my $tope= qtre_numlines () - 1;
	qtre_down () while (qtre_line () < $tope);
}

1;
# Fin de qtre.pl