// abrick.cpp

#include <unistd.h> // Para sleep y usleep
#include <cstdlib> // para random
#include <string>
#include <vector>

#include "termstream.h"

class VieneElJefe {};

const short
	colormarco= 1,
	colorexplosion= 2,
	colorpresenta= 3,
	colorpelota= 4,
	colorraqueta= 5;

class Pelota {
	short maxcol, linea, columna, inccol, inclin, maxefe;
public:
	Pelota (short mcol, short mefe)
	{
		maxcol= mcol;
		maxefe= mefe;
		linea= 16;
		columna= random () % maxcol;
		inccol= 1; inclin= -1;
	}
	void mueve ()
	{
		linea+= inclin;
		if (linea < 0) { vinvert (); linea= 1; }
		columna+= inccol;
		if (columna < 0) {
			inccol= -inccol;
			columna= 1;
		}
		if (columna >= maxcol) {
			inccol= -inccol;
			columna= (maxcol - 1) * 2 - columna;
		}
	}
	inline short lin () { return linea; }
	inline short col () { return columna; }
	inline void lin (short l) { linea= l; }
	inline void vinvert () { inclin= -inclin; }
	void efecto ()
	{
		int e= 1 + random () % (maxefe - 1);
		if (inccol > 0) inccol= e;
		else inccol= -e;
	}
};

class Juego {
public:
	Juego (otermstream &otnue, int niv);
	void jugar ();
private:
	void campo ();
	void explosion ();
	void ponpuntos ();
	inline bool tocaRaqueta ()
	{
		return pel.lin () == raqlin && 
			pel.col () >= raqcol && pel.col () < raqcol + anchoraq;
	}
	inline void borraPelota ()
	{
		ot << at (pel.lin () + inilin, pel.col () + inicol) <<
			" " << flush;
	}
	inline void ponPelota ()
	{
		ot << at (pel.lin () + inilin, pel.col () + inicol) <<
			color (colorpelota) << "O" << color (0) << flush;
	}
	otermstream &ot;
	int retardo;
	static const int anchoraq= 8;
	static const int raqlin= 18;
	static const int inilin= 4;
	static const int inicol= 5;
	//static const int maxcol= 69;
	static const int maxcol= 66;
	int maxinc;
	int puntos;
	int raqcol;
	Pelota pel;
	unsigned short ladrillo [raqlin] [maxcol / 3];
};

Juego::Juego (otermstream &otnue, int niv) :
	ot (otnue), pel (maxcol, maxinc - 1)
{
	puntos= 0;
	switch (niv) {
	case 0:  retardo= 150000; maxinc= 4; break;
	case 1:  retardo= 150000; maxinc= 5; break;
	case 2:  retardo=  90000; maxinc= 5; break;
	default: retardo=  60000; maxinc= 5;
	}
	srandom (time (0) );
	for (int i= 0; i < raqlin; ++i)
		for (int j= 0; j < maxcol / 3; ++j)
			ladrillo [i] [j]= 0;
}

void Juego::campo ()
{
	ot << clrscr <<
		at (1, 30) << color (colorpresenta) << inverse (true) <<
		" ANOTHER BRICK " << inverse (false) <<
		color (colormarco) << inverse (true) <<
		at (inilin - 1, inicol - 1) << string (maxcol + 2, ' ');
	for (int lin= inilin; lin < inilin + raqlin; ++lin)
		ot << at (lin, inicol - 1) << ' ' <<
			at (lin, inicol + maxcol) << ' ';
	ot << inverse (false) << color (0);
}

void Juego::explosion ()
{
	int l= raqlin + 1 + inilin,
		c= pel.col () - 3 + inicol;
	int s= 100000;
	ot.color (colorexplosion);
	const char * explo []= {
		"   *   ",
		"  ***  ",
		" ***** ",
		"*** ***",
		"**   **",
		"*     *",
		"       "
	};
	for (size_t i= 0; i < sizeof (explo) / sizeof (explo [0]); ++i) {
		ot << at (l,c ) << explo [i] << flush;
		usleep (s);
	}
	usleep (s * 4);
	ot.color (0);
}

void Juego::ponpuntos ()
{
	ot << at (1, 8) << puntos;
}

void Juego::jugar ()
{
	using std::string;

	int posmax= maxcol - anchoraq;
	raqcol= posmax / 2;
	int inue, inc= 0;
	campo ();
	string raqueta= string (maxinc, ' ') + string (anchoraq, '-') +
		string (maxinc, ' ');
	for (int i= 2; i < 4; ++i) {
		ot << at (i + inilin, inicol) << string (maxcol, '=');
		for (int j= 0; j < maxcol / 3; ++j)
			ladrillo [i] [j]= 40;
	}
	for (int i= 5; i < 7; ++i) {
		ot << at (i + inilin, inicol) << string (maxcol, '$');
		for (int j= 0; j < maxcol / 3; ++j)
			ladrillo [i] [j]= 20;
	}
	for (int i= 8; i < 10; ++i) {
		ot << at (i + inilin, inicol) << string (maxcol, '%');
		for (int j= 0; j < maxcol / 3; ++j)
			ladrillo [i] [j]= 10;
	}
	for (;;) {
		switch (ot.getkey () ) {
		case 'm': case 'M': case key::Right:
			if (inc > 0) ++inc;
			else inc= 1;
			break;
		case 'n': case 'N': case key::Left:
			if (inc < 0) --inc;
			else inc= -1;
			break;
		case ' ': case key::Down:
			inc= 0;
			break;
		case key::F1: // Una prueba
			sleep (2);
			break;
		case 'q': case 'Q':
			throw VieneElJefe ();
		}
		if (inc > maxinc)  inc= maxinc;
		if (inc < -maxinc) inc= -maxinc;
		inue= raqcol + inc;
		if (inue < 0) inue= 0;
		if (inue > posmax) inue= posmax;
		raqcol= inue;
		borraPelota ();

		ot << at (raqlin + inilin, raqcol + inicol - maxinc) <<
			color (colorraqueta) << raqueta << color (0) <<
			flush;

		pel.mueve ();
		if (tocaRaqueta () ) {
			pel.lin (raqlin - 2);
			pel.vinvert ();
			pel.efecto ();
		}
		if (pel.lin () >= raqlin) {
			explosion ();
			break;
		}
		int l= pel.lin ();
		int c= pel.col () / 3;
		if (ladrillo [l] [c] != 0) {
			puntos+= ladrillo [l] [c];
			ponpuntos ();
			ladrillo [l] [c]= 0;
			ot << at (l + inilin, c * 3 + inicol) <<
				"   ";
			pel.vinvert ();
			//pel.efecto ();
		}
		ponPelota ();
		usleep (retardo);
	}
	ot << at (1, 1);
}

class Opcion {
	otermstream &ot;
	std::vector<std::string> op;
	void put (int n)
		{ ot << at (2 * n + 10, 35) << op [n]; }
	void normal (int n)
		{ put (n); }
	void selected (int n)
		{ ot << inverse (true); put (n); ot << inverse (false); }
public:
	Opcion (otermstream &nueop) :
		ot (nueop) {}
	void add (std::string nueop)
		{ op.push_back (nueop); }
	int choice (int inicial= 0);
};

int Opcion::choice (int inicial)
{
	ot.color (colorraqueta);
	size_t numops= op.size ();
	for (size_t i= 0; i < numops; ++i)
		normal (i);
	int actual= inicial, anterior= -1;
	int c;
	do {
		if (anterior != actual) {
			if (anterior != -1)
				normal (anterior);
			selected (actual);
			anterior= actual;
		}
		c= ot.getkey ();
		switch (c) {
		case key::Down: case 'z': case 'Z':
			actual= (actual + 1) % numops;
			break;
		case key::Up: case 'a': case 'A':
			actual= (actual + numops - 1) % numops;
			break;
		case '\r':
			break;
		case 'q': case 'Q':
			throw VieneElJefe ();
		}
	} while (c != '\r' && c != '\n');
	ot.color (0);
	return actual;
}

void presenta (otermstream &ot)
{
	ot << clrscr << at (1, 30) <<
		color (colorpresenta) << inverse (true) <<
		"---------------" << at (2, 30) <<
		" ANOTHER BRICK " << at (3, 30) <<
		"---------------" <<
		inverse (false) << at (5, 30) <<
		"(C) Julian Albo" << color (0) << flush;
}

int main (void)
{
	otermstream ot;
	try {
		ot.cursor (false);
		ot.setcolor (colormarco, Color::Blue, Color::Black);
		ot.setcolor (colorexplosion, Color::Red, Color::Black);
		ot.setcolor (colorpresenta, Color::Yellow, Color::Black);
		ot.setcolor (colorpelota, Color::Green, Color::Black);
		ot.setcolor (colorraqueta, Color::Cyan, Color::Black);
		bool continua= true;
		int nivel= 0;
		do {
			presenta (ot);
			int r;
			{
				Opcion opcion (ot);
				opcion.add ("Jugar");
				opcion.add ("Cambiar nivel");
				opcion.add ("Terminar");
				r= opcion.choice ();
			}
			switch (r) {
			case 0:
				{
					ot << delay (false);
					Juego juego (ot, nivel);
					juego.jugar ();
					ot << delay (true);
				}
				break;
			case 1:
				{
					Opcion opnivel (ot);
					opnivel.add ("Principiante");
					opnivel.add ("Aficionado");
					opnivel.add ("Profesional");
					opnivel.add ("Superman");
					presenta (ot);
					nivel= opnivel.choice (nivel);
				}
				break;
			case 2:
				continua= false;
			}
		} while (continua);
	}
	catch (VieneElJefe &) {
		ot << clrscr;
	}
	catch (...) {
		ot << "Error inesperado";
	}
	return 0;
}

// Fin de abrick.cpp
