// menu.cpp

#include "menu.h"
#include <assert.h>
#define ASSERT assert

Menu::Menu (otermstream & not) :
	ot (not)
{
	clear= std::string (ot.columns (), ' ');
	numopts= 0;
	fRecalc= false;
}

void Menu::calcpositions ()
{
	numopts= options.size ();
	size_t position= 1;
	for (size_t i= 0; i < numopts; ++i) {
		options [i].pos (position);
		position+= options [i].text ().size () + 1;
	}
	fRecalc= false;
}

void Menu::putopt (size_t nopt)
{
	ot << at (0, options [nopt].pos () - 1) <<
		' ' << options [nopt].text () << ' ' << flush;
}

void Menu::show ()
{
	if (fRecalc)
		calcpositions ();
	ot << at (0, 0) << inverse (true) << clear;
	//ot << at (0, 1) << "F2";
	for (size_t i= 0; i < options.size (); ++i)
		ot << at (0, options [i].pos () ) << options [i].text ();
	ot << flush;
}

void Menu::redraw (size_t active)
{
	ot << at (0, 0) << inverse (true) << clear;
	for (size_t i= 0; i < options.size (); ++i) {
		if (i == active) ot << inverse (false);
		ot << at (0, options [i].pos () ) << options [i].text ();
		if (i == active) ot << inverse (true);
	}
}

bool Menu::select (IdMenu * selected)
{
	ASSERT (selected != 0);
	size_t active= 0;
	size_t prev= size_t (0) - 1;
	bool fSelecting= true;
	bool fSelected= false;
	do {
		if (prev != active) {
			if (prev != size_t (0) - 1) {
				ot << inverse (true);
				putopt (prev);
			}
			ot << inverse (false);
			putopt (active);
			prev= active;
		}
		switch (ot.getkey () ) {
		case '\r': case '\n':
			if (options [active].type () == Option::Sub) {
				Menu & submenu= options [active].submenu ();
				submenu.show ();
				if (submenu.select (selected) ) {
					fSelected= true;
					fSelecting= false;
				}
				redraw (active);
			}
			else {
				fSelected= true;
				fSelecting= false;
				* selected= options [active].getId ();
			}
			break;
		case '\x1B': // Escape
			fSelecting= false;
			break;
		case key::Left:
			active= (active + numopts - 1) % numopts;
			break;
		case key::Right:
			active= (active + 1) % numopts;
			break;
		}
	} while (fSelecting);
	ot << inverse (true);
	putopt (active);
	return fSelected;
}

// Fin de menu.cpp