// menu.h

#include <string>
#include <vector>
#include "termstream.h"

typedef unsigned int IdMenu;

class Menu;

class Option {
public:
	typedef enum { Com, Sub } TypeOption;
	Option (std::string ntext, IdMenu nid) :
		str (ntext), id (nid), to (Com)  {}
	Option (std::string ntext, Menu * nmenu) :
		str (ntext), menu (nmenu), to (Sub) {}
	const std::string text () { return str; }
	IdMenu getId () { return id; }
	void pos (short npos) { position= npos; }
	short pos () { return position; }
	TypeOption type () { return to; }
	Menu & submenu () { return * menu; }
private:
	std::string str;
	IdMenu id;
	Menu *menu;
	TypeOption to;
	short position;
};

class Menu {
public:
	Menu (otermstream & not);
	void addOption (const Option & nop)
		{ options.push_back (nop); fRecalc= true; }
	void show ();
	bool select (IdMenu * selected);
private:
	otermstream &ot;
	std::vector<Option> options;
	std::string clear;
	size_t numopts;
	bool fRecalc;
	void calcpositions ();
	void redraw (size_t active);
	void putopt (size_t nopt);
};

// Fin de menu.h