/*
	qperl.c
*/

#include <EXTERN.h>
#include <XSUB.h>
#include <perl.h>

#include "qperl.h"

qpFunc gfunc;
void * gdata;

XS (qtre_up)
{
	dXSARGS;
	if (items != 0)
		XSRETURN_UNDEF;
	gfunc (gdata, qpUp, 0, NULL);
}

XS (qtre_down)
{
	dXSARGS;
	if (items != 0)
		XSRETURN_UNDEF;
	gfunc (gdata, qpDown, 0, NULL);
}

XS (qtre_left)
{
	dXSARGS;
	if (items != 0)
		XSRETURN_UNDEF;
	gfunc (gdata, qpLeft, 0, NULL);
}

XS (qtre_right)
{
	dXSARGS;
	if (items != 0)
		XSRETURN_UNDEF;
	gfunc (gdata, qpRight, 0, NULL);
}

XS (qtre_home)
{
	dXSARGS;
	if (items != 0)
		XSRETURN_UNDEF;
	gfunc (gdata, qpHome, 0, NULL);
}

XS (qtre_end)
{
	dXSARGS;
	if (items != 0)
		XSRETURN_UNDEF;
	gfunc (gdata, qpEnd, 0, NULL);
}

XS (qtre_gotoline)
{
	int line;
	dXSARGS;
	if (items != 1)
		XSRETURN_UNDEF;
	line= SvIV (ST (0) );
	gfunc (gdata, qpGotoLine, line, NULL);
}

XS (qtre_getchar)
{
	char c;
	dXSARGS;
	if (items != 0)
		XSRETURN_UNDEF;
	c= gfunc (gdata, qpGetChar, 0, NULL);
	if (c != 0)
		ST (0)= sv_2mortal (newSVpv (&c, 1) );
	else ST (0)= & PL_sv_undef;
	XSRETURN (1);
}

XS (qtre_delete)
{
	dXSARGS;
	if (items != 0)
		XSRETURN_UNDEF;
	gfunc (gdata, qpDelChar, 0, NULL);
}

XS (qtre_deleteline)
{
	dXSARGS;
	if (items != 0)
		XSRETURN_UNDEF;
	gfunc (gdata, qpDelLine, 0, NULL);
}

XS (qtre_replaceline)
{
	char *str;
	STRLEN len;
	dXSARGS;
	switch (items) {
	case 0:
		str= ""; break;
	case 1:
		str= SvPV (ST (0), len); break;
	default:
		XSRETURN_UNDEF;
	}
	gfunc (gdata, qpReplaceLine, 0, str);
}

XS (qtre_insert)
{
	char *str;
	STRLEN len;
	dXSARGS;
	if (items != 1)
		XSRETURN_UNDEF;
	str= SvPV (ST (0), len);
	gfunc (gdata, qpInsText, 0, str);
}

XS (qtre_line)
{
	int n;
	dXSARGS;
	if (items != 0)
		XSRETURN_UNDEF;
	n= gfunc (gdata, qpLine, 0, NULL);
	XSRETURN_IV (n);
}

XS (qtre_numlines)
{
	int n;
	dXSARGS;
	if (items != 0)
		XSRETURN_UNDEF;
	n= gfunc (gdata, qpNumlines, 0, NULL);
	XSRETURN_IV (n);
}

XS (qtre_status)
{
	char *str;
	STRLEN len;
	dXSARGS;
	if (items != 1)
		XSRETURN_UNDEF;
	str= SvPV (ST (0), len);
	gfunc (gdata, qpStatus, 0, str);
}

XS (qtre_getline)
{
	int n;
	int nline;
	char * str;
	dXSARGS;
	switch (items) {
	case 0:
		nline= gfunc (gdata, qpLine, 0, NULL);
		break;
	case 1:
		nline= SvIV (ST (0) );
		break;
	default:
		XSRETURN_UNDEF;
	}
	n= gfunc (gdata, qpCharLine, nline, NULL);
	str=  malloc (n + 1);
	if (str == NULL)
		XSRETURN_UNDEF;
	gfunc (gdata, qpGetLine, nline, str);
	//XSRETURN_PV (str);
	ST(0)= sv_2mortal (newSVpv (str, 0) );
	free (str);
	XSRETURN (1);
}

static PerlInterpreter *MyPerl;
static char * pl_argv [] = { "", "/usr/etc/qtre.pl" };

void qperl_init (char * * env)
{
	char * strAux;
	char strPackage [256];
	static char module []= "qperl.c";
	MyPerl= perl_alloc ();
	perl_construct (MyPerl);
	perl_parse (MyPerl, NULL,
		sizeof (pl_argv) / sizeof (pl_argv [0] ), pl_argv, env);

	strAux= getenv ("HOME");
	if (strAux == NULL) strAux= ".";
	strcpy (strPackage, strAux);
	if (strPackage [0] != '\0' &&
			strPackage [strlen (strPackage) - 1] != '/')
		strcat (strPackage, "/");
	strcat (strPackage, ".qtre.pl");
	perl_require_pv (strPackage);

	newXS ("qtre_up",          qtre_up, module);
	newXS ("qtre_down",        qtre_down, module);
	newXS ("qtre_left",        qtre_left, module);
	newXS ("qtre_right",       qtre_right, module);
	newXS ("qtre_home",        qtre_home, module);
	newXS ("qtre_end",         qtre_end, module);
	newXS ("qtre_gotoline",    qtre_gotoline, module);
	newXS ("qtre_getchar",     qtre_getchar, module);
	newXS ("qtre_delete",      qtre_delete, module);
	newXS ("qtre_insert",      qtre_insert, module);
	newXS ("qtre_numlines",    qtre_numlines, module);
	newXS ("qtre_line",        qtre_line, module);
	newXS ("qtre_status",      qtre_status, module);
	newXS ("qtre_deleteline",  qtre_deleteline, module);
	newXS ("qtre_replaceline", qtre_replaceline, module);
	newXS ("qtre_getline",     qtre_getline, module);
}

void qperl_destroy (void)
{
	perl_destruct (MyPerl);
	perl_free (MyPerl);
}

int qperl_macro (char cMac, qpFunc func, void * data)
{
	char macro [32];
	dSP;
	PUSHMARK (SP);
	gfunc= func; gdata= data;
	sprintf (macro, "qtre_macro_%c", cMac);
	if (perl_get_cv (macro, 0) != NULL) {
		perl_call_pv (macro,
			G_VOID | G_DISCARD | G_NOARGS /* | G_EVAL*/);
		return 0;
	}
	else return 1;
}

/* Fin de qperl.c */
